import { Accessor } from './Accessor';
const get = require('lodash/get');
export class SuggestionsAccessor extends Accessor {
    constructor(field) {
        super();
        this.field = field;
    }
    getSuggestion() {
        return get(this.searchkit.getSuggestions(), [0, 'options', 0, 'text'], false);
    }
    buildOwnQuery(query) {
        const queryText = query.getQueryString();
        if (queryText.length > 3) {
            return query.setSuggestions({
                text: queryText,
                suggestions: {
                    phrase: {
                        field: this.field,
                        real_word_error_likelihood: 0.95,
                        max_errors: 1,
                        gram_size: 4,
                        direct_generator: [
                            {
                                field: this.field,
                                suggest_mode: 'always',
                                min_word_length: 1
                            }
                        ]
                    }
                }
            });
        }
        return query;
    }
}
//# sourceMappingURL=SuggestionsAccessor.js.map